#!/bin/bash

HELAC="$1"
RUN="$2"
SUMPR="$HELAC"/Summation_Processes/
AFSDIR="$3"
QUEUE="$4"

Q[1]=8nm
Q[2]=1nh
Q[3]=8nh
Q[4]=1nd
Q[5]=2nd
Q[6]=1nw
Q[7]=2nw

rm -f results.output

$FC $SUMPR/processes.f
./a.out < infile

$FC $SUMPR/prodinput.f

for j in *all
do
	echo $j > temporaryfile1
done

./a.out < temporaryfile1

for j in cinput*
do
	k=$((k+1))
done

echo $k > temporaryfile

sed -n 3p cinput1 >> temporaryfile

cp $HELAC/main_mc_dp.exe $AFSDIR

for i in `seq 1 $k`
do
	mv cinput$i $AFSDIR

	bsub -q $QUEUE -J "sub1.$i" -o $AFSDIR/sub1.$i.out -e $AFSDIR/sub1.$i.err $AFSDIR/Summation_Processes/onesub2.sh $AFSDIR $i "$HOST":"$SUMPR"

	status[$i]=0
	#status: 0=submitted, 1=finished but error log not yet checked, 2=finished with no errors
done

alldone=0

until [ $alldone -eq 1 ]
do
	sleep 15

	alldone=1

	for i in `seq 1 $k`
	do
		if [ ${status[$i]} -eq 0 ]
		then
			if [ -r dummy$i ]
			then
				if [ ! -d directory_$i ]
				then
					date
					echo Uncompressing directory $i
					tar zxf directory_$i.tar.gz
					rm directory_$i.tar.gz

					date
					echo directory $i uncompressed

					status[$i]=1
				fi
			fi
		fi

		if [ ${status[$i]} -eq 1 ]
		then
			if [ -r $AFSDIR/sub1."$i".err ] #if file exists
			then
				if [ -s $AFSDIR/sub1."$i".err ] #if file is not empty
				then
					status[$i]=0
					alldone=0

					CQ=`grep "$AFSDIR"/sub1."$i".out -e"Job was executed" | awk '{print $9}' | awk -F\< '{print $2}' | awk -F\> '{print $1}'`

					rm -rf directory_$i
					rm dummy$i
					mv $AFSDIR/sub1."$i".out  $AFSDIR/sub1."$i".unsuccessful.out
					mv $AFSDIR/sub1."$i".err  $AFSDIR/sub1."$i".unsuccessful.err

					for j in `seq 1 7`
					do
						if [ $CQ = ${Q[$j]} ]
						then
							qn0=$j
						fi
					done

					date
					echo job $i unsuccessfully finished on queue ${Q[$qn0]}

					if [ $qn0 -ne 7 ]
					then
						qn1=$((qn0+1))
					else
						qn1=$qn0
					fi

					echo and resubmitted on queue ${Q[$qn1]}

					if [ $qn0 -eq $qn1 ]
					then
						touch $AFSDIR/MAXQUEUE_"$i"
					fi

					bsub -q ${Q[qn1]} -J "sub1.$i" -o $AFSDIR/sub1.$i.out -e $AFSDIR/sub1.$i.err $AFSDIR/Summation_Processes/onesub2.sh $AFSDIR $i "$HOST":"$SUMPR"
				else
					status[$i]=2
					rm $AFSDIR/cinput$i

					date
					echo job $i successfully finished
				fi
			fi
		fi

		if [ ${status[$i]} -ne 2 ]
		then
			alldone=0
		fi
	done
done

date
echo First phase finished

rm dummy*

mv $AFSDIR/sub1.* $HELAC/$RUN/1

for i in `seq 1 $k`
do
	cd directory_$i

	test=`grep output -e"average estimate"`

	if [ -n  "$test"  ]

	then
		grep output -e"average estimate" | awk '{print $4}' >> ../results.output
		grep output -e"variance estimate" | awk '{print $3}' >> ../results.output
	else
		echo "0" >> ../results.output
		echo "0" >> ../results.output
	fi

	echo >> ../results.output

	rm -f data*
	gzip kine_*
	gzip even*out
	gzip output
	gzip err_file

	cd ..
done

$FC $SUMPR/readoutput1.f
./a.out >& $HELAC/$RUN/1/output
