C-----------------------------------------------------------       
      subroutine ktclus(n,io(1:n),pmom(1:n,1:4))
      include 'declare.h'

      common/clus/io(1:n),icol_cl(20,2),pcl(20,4)

      do i=1,n
       pcl(i,1:4)=pmom(i,1:4)
      enddo

      np=n
      
 1    continue
      ifound=0
      i0=0
      j0=0
      dmin=1d13
      if(np.eq.0)return

      do i=1,np-1
       do j=i+1,np
         d=dist(i,j)
         if(d.lt.dmin)then
          ifound=1
          i0=i
          j0=j
          dmin=d
         endif
       enddo
      enddo

      if(ifound.eq.1)then
       call combine(i0,j0)
       np=np-1
c call weight       
       if(dmin.lt.0)print*,dmin,w,np,i0,j0
       goto 1
      endif

      return
      end
 
      function dist(i,j)
      include 'declare.h'
      include 'common_int.h'
      common/clus/io(1:n),icol_cl(20,2),pcl(20,4)

      pt1=pcl(i,1)**2+pcl(i,2)**2
      pt2=pcl(j,1)**2+pcl(j,2)**2
   
c initial-final
      if(io(i).eq. 1.and.io(j).eq.-1)then
       dist=pt2
      endif
c final-initial
      if(io(i).eq.-1.and.io(j).eq. 1)then
       dist=pt1
      endif
c final-final
      if(io(i).eq.-1.and.io(j).eq.-1)then
       y1=-0.5d0*dlog((pcl(i,4)-pcl(i,3))/(pcl(i,4)+pcl(i,3)))
       y2=-0.5d0*dlog((pcl(j,4)-pcl(j,3))/(pcl(j,4)+pcl(j,3)))
       dphi=(pcl(i,1)*pcl(j,1)+pcl(i,2)*pcl(j,2))/dsqrt(pt1*pt2)
       if(dphi.lt.-1d0.and.dphi.gt.-1d0-1d-6)dphi=-1.d0
       dphi=dacos(dphi)
       dist=min(pt1,pt2)*((y1-y2)**2+dphi**2)
       if(dist.lt.0)print*,i,j,y1,y2,dphi,pt1,pt2
       if(dist.lt.0)print*,i,pcl(i,1:4)
       if(dist.lt.0)print*,j,pcl(j,1:4)
      endif
c initial-initial
      if(io(i).eq. 1.and.io(j).eq. 1)then
       dist=1d14
      endif
c
      return
      end

      subroutine combine(i,j)
      include 'declare.h'
      include 'common_int.h'
      common/clus/io(1:n),icol_cl(20,2),pcl(20,4)
      real*8 p(4)

      i1=min(i,j)
      j1=max(i,j)

      p(1:4)=io(i)*pcl(i,1:4)+io(j)*pcl(j,1:4)
      if(p(4).lt.0)p(1:4)=-p(1:4)

      pcl(i1,1:4)=p(1:4)
      pcl(j1:n-1,1:4)=pcl(j1+1:n,1:4)

      return
      end

